#define SERVERONLY
#include <Ole.h>
#include <Shellapi.h>

// -------- Data types
typedef struct _TEXTOBJECT
{
	LPOLEOBJECTVTBL		lpvtbl;		// Callbacks table
    BOOL				fRelease;	// Wait flag
	LPOLECLIENT			lpClient;	// For notifications
    HANDLE				hmem;		// Memory handle for this structure
}
				TEXTOBJECT, FAR *LPTEXTOBJECT;

typedef struct _TEXTDOC
{
	LPOLESERVERDOCVTBL	lpvtbl;		// Callbacks table
	LHSERVERDOC			lh;			// Pour OleRegisterServer
    BOOL				fRelease;	// Wait flag
	ATOM				aObject;	// Doc object name
	ATOM				aClient;	// Connected client name
    HANDLE				hmem;		// Memory handle for this structure
	LPTEXTOBJECT		lpObj;		// Last allocated object
}
				TEXTDOC, FAR *LPTEXTDOC;

typedef struct _TEXTSERVER
{
	LPOLESERVERVTBL		lpvtbl;		// Callbacks table
    LHSERVER			lh;			// For OleRegisterServer
    BOOL				fRelease;	// Wait flag
    BOOL				fEmbed;		// TRUE if only embedding
    BOOL				fLink;		// TRUE if only linking
    HWND				hwnd;		// Main window
    WORD				nCmdShow;	// Show indicator
    BOOL				fObjShown;	// Indicates visible object
    HANDLE				hmem;		// Memory handle for this structure
    LPTEXTDOC			lpDoc;		// Last allocated object
}
				TEXTSERVER, FAR *LPTEXTSERVER;

// -------- Global variable
struct
{
	LPTEXTSERVER		lpSvr;		// TEXTSERVER structure

// ---- Callbacks tables
	OLESERVERVTBL		vtblSvr;
	OLESERVERDOCVTBL	vtblDoc;
	OLEOBJECTVTBL		vtblObj;

// ---- Clipboard formats
	WORD		cfNative;			// Native clipboard format
	WORD		cfOwnerLink;		// OwnerLink clipboard format
}
				OleGbl;
